%{
/*
	                  <calcul.l>

		Calculette:	Analyse Lexicale.
*/

#include		"calcul.h"
#include		"calcul.tab.h"


static	int	inter;
static	int	wi;

%}

BLANCS [ \t]+


%%

{BLANCS}	{ /* On ignore */ }


"--".*		{
		ECHO;
		printf ("\n");
		}

sin		{
		yylval = its_sinus;
		return (F);
		}

cos		{
		yylval = its_cosinus;
		return (F);
		}

[a-z]+		{
		for (wi = 0; wi < TailleDic; wi++)
			{
			if (! strcmp (Dic[wi].n, yytext))
				{
				yylval = wi;
				return (variable);
				}
			}
		yylval = TailleDic;
		TailleDic++;
		strcpy (Dic[yylval].n, yytext);
		return (variable);
		}

[0-9]+		{
		myECHO;
		yylval = TailleDic;
		TailleDic++;
		inter = atoi(yytext);
		Dic[yylval].v = inter;
		return (valeur);
		}

\n		return (yytext[0]);
		

[-+*/()=]       return yytext[0];   /* caracteres unites lexicales */

.		fprintf(stderr, "Caractere (%c) non reconnu\n", yytext[0]);
		

%%

int		yywrap		()
	{
	return	(1);
	}
