%{
/*
	<calcul2.y>

		Calculette:		Analyse Syntaxique.
*/

#include	"calcul.h"
#define		vu(a)	printf ("%s", a);
#define		genereaux1	printf ("\n\ncode instruction"		\
					"\n\t\t1er operande\n");	\
				printf ("---\t---\t---\t---\t---\t---\n");

#define		genereOp(a)		printf ("\n\t%d",a);
#define		genere(a, b) printf ("\n\t%d\t%d", a, b);
%}

%token		F
%token		variable
%token		valeur
%left		'+' '-'
%left		'*' '/'

%start		essai

%%

terme	:	F '(' formule ')'
	{
	switch ($1)
		{
		case	its_sinus:	
			{
			genereOp (its_sinus);
			}
			break;

		case	its_cosinus:
			{
			genereOp (its_cosinus);
			}
			break;
		}
	}
	;

formule	:	formule '+' formule
	{
	genereOp (its_add);
	}
	|	formule '-' formule
	{
	genereOp (its_sub);
	}
	|	formule '*' formule
	{
	genereOp (its_mul);
	}
	|	formule '/' formule
	{
	genereOp (its_div);
	}
	|	terme
	{
	}
	|	variable
	{
	genere (its_empiler, $1);
	}
	|	valeur
	{
	genere (its_empiler, $1);
	}
	|	'(' formule ')'
	{
	}
	;

ligne	:	variable '=' formule '\n' 
	{
	genere (its_depiler, $1);
	genereaux1;
	}
	|	'\n'
	{
	}
	;

essai	:	essai	ligne
	|	ligne
	;

%%

int	main	(int argc, char * argv[])
{
	int	rc;

	printf	("\nPetit compilateur sans branchements dans le code:\n");
	rc = yyparse ();
	printf	("\nCode retour de 'yyparse()':%d\n\n", rc);

	printf	("\n\n\tContenu du dictionnaire de donnees:\n\n");
	for	(rc = 0; rc < TailleDic; rc++)
		{
		 printf ("\t%f\t%s\n", Dic[rc].v, Dic[rc].n);
		}
}